import { useUserStore } from "@/stores/modules/userStore";

const userStore = useUserStore();
const token = userStore.userInfo?.token;
const baseURL = import.meta.env.VITE_APP_BASE_API;

const decoder = new TextDecoder("utf-8");

// 解码 UTF-8 字符串
const decodeUTF8 = arrBuff => decoder.decode(new Uint8Array(arrBuff));

// stream request - chat
export const streamChatRequest = async ({ data, onProgress, messages, onComplete, onError, onAbort } ) => {

  const url = baseURL + '/grpc/inferStreamRag'
  const Authorization = "Bearer " + token;

  let isStopped = false;
  let typedResult = "";

  const requestTask = uni.request({
    url,
    enableChunked: true,
    method: "POST",
    header: {
      "Content-Type": "application/json",
      Authorization,
    },
    data,
    success: (res) => {
      console.log("请求完成", res);
    },
    fail: (err) => {
      onError(err);
    },
  });

  let accumulatedText = "";
  let fullMessage = "";

  requestTask.onChunkReceived(async (res) => {
    const uint8Array = new Uint8Array(res.data);
    const chunkText = decodeUTF8([...uint8Array]);
    accumulatedText += chunkText;
    onProgress && onProgress(accumulatedText);
  });

  return () => {
		console.log('中断请求...');
		isStopped = true;

		requestTask.abort();

	};
};
